#include <math.h>
#include <stdio.h>
#include <stddef.h>
        double r = 28.0,s = 10.0,b = 8.0/3.0;
void main()
        {
        double *equilibrium, *dvector();
        double *evone;
        double *evtwo;
        int u_flag,dim;
        dim = 3;
        u_flag = -1.0;
        equilibrium = dvector(0,dim-1);
        evone = dvector(0,dim-1);
        evtwo = dvector(0,dim-1);
        equilibrium[0] = 0.0;
        equilibrium[1] = 0.0;
        equilibrium[2] = 0.0;
        evone[0] = -.614817;
        evone[1] = 0.78867;
        evone[2] = 0.0;
        evtwo[0] = 0.0;
        evtwo[1] = 0.0;
        evtwo[2] = 1.0;
        two_d_mfld(dim,equilibrium,evone,evtwo,u_flag);
        
}

two_d_mfld(dim,equilibrium,evone,evtwo,u_flag)
int dim,u_flag;
double equilibrium[],evone[],evtwo[];
{
double **p, **r, **ring, **rm,*dvector(), *vf;
int i,j,k,l, rno_init, rno, j_new, inter, pno,ring_no, last2_ind,last_ind,next_ind;
double dist(),length(),delman,*en1,*en2,*ep,dot12;
double twopi,dot(), *dir,*current, *diff, *last, *next, *last2,delta;
double sin(),cos(), max_ring_length, min_ring_length, min_length; 
double max_length, len_dir, length1, lengthp;
void  fp(), per_proj();
size_t max_point_no;

dim = 3;
max_point_no = 100000;
delman = 4.0;
twopi = 6.28318530717958648;
rno_init = 12;
min_length = 0.001;
max_length = 0.1;
max_ring_length = 3.0;
min_ring_length = 1.5;
ring_no = 1000;
r = (double **) calloc(max_point_no/10,sizeof(double *));
for (i=0;i<max_point_no;i++) r[i] = (double *) calloc(dim,sizeof(double));
ring = (double **) calloc(max_point_no/10,sizeof(double *));
for (i=0;i<max_point_no;i++) ring[i] = (double *) calloc(dim,sizeof(double));
rm = (double **) calloc(max_point_no/10,sizeof(double *));
for (i=0;i<max_point_no;i++) rm[i] = (double *) calloc(dim,sizeof(double));

/*Compute the initial points of manifold as inscribed polygon of rno_init sides
  in circle centered at equilibrium with radius delman */

l = -1;
pno = 0; 
en1 = dvector(0,dim-1); 
ep = dvector(0,dim-1); 
en2 = dvector(0,dim-1);
vf = dvector(0,dim-1);
 
length1 = length(dim,evone);
for (i=0;i<dim;i++)
        en1[i] = evone[i]/length1;
per_proj(dim,evtwo,en1,ep);
lengthp = length(dim,ep);
for (i=0;i<dim;i++) en2[i] = ep[i]/lengthp;
for (j=0;j<rno_init;j++) {
        for (i=0;i<dim;i++) {
        r[j][i] = equilibrium[i] + delman*(cos(1.0+twopi*j/rno_init)*en1[i] + sin(1.0+twopi*j/rno_init)*en2[i]);
        }
print_point(r[j],dim,l+2);

}

rno=rno_init;
dir = dvector(0,dim-1);
diff = dvector(0,dim-1);

/* Integrate current ring of rno points in array r to next ring: 
   ring is provisional array */ 

for (l=0;l<ring_no;l++){
for (j=0;j<rno;j++) {
        current = r[j];
        if (j>0) last = r[j-1]; else last = r[rno-1];
        if (j<rno-1) next = r[j+1]; else next = r[0];
        for (i=0;i<dim;i++) diff[i] = next[i]-last[i];
        fp(vf, current, dim);
        per_proj(dim,vf,diff,dir);
        len_dir = length(dim,dir);

delta = max_length/len_dir;
        for (i=0;i<dim;i++) ring[j][i] = current[i]+u_flag*delta*dir[i];
        }

/* Interpolate points into r_temp and rewrite array r */

j_new = 0;
for (j=0;j<rno;j++) {
        last_ind = (j+rno-1)%rno;
        last = ring[last_ind];
        current = ring[j];
        delta = dist(dim,last,ring[j]);
	if (delta > min_ring_length) {
                for (i=0;i<dim;i++) rm[j_new][i] = ring[j][i];
                j_new++;}
        }
rno = j_new;
j_new = 0;

for (j=0;j<rno;j++) {
        last_ind = (j+rno-1)%rno;
        last = rm[last_ind];
        current = rm[j];
        delta = dist(dim,last,rm[j]);
        if (delta > max_ring_length) {
                last2_ind = (j+rno-2)%(rno);
                last2 = ring[last2_ind];
                next_ind = (j+1)%rno;
                next = ring[next_ind];
                for (i=0;i<dim;i++) {
                r[j_new][i] = (-1.0*last2[i]+9.0*last[i]+9.0*current[i]-1.0*next[i])/16.0;
                r[j_new+1][i] = rm[j][i];}
                j_new = j_new+2;
        }
	else {for (i=0;i<dim;i++) r[j_new][i] = rm[j][i];
                j_new++;}
}
rno = j_new;
/* printf("%d %d\n", l, rno); */

/* Update point list */

if ((l%20) == 0) for (j=0;j<rno;j++) print_point(r[j],dim,l/20+2);       
}}

print_point(point,dim,index)
double *point;
int dim, index;
{ 

        int i ;
        printf("%%XC%d ", index);
        for(i=0;i<dim;i++) printf("%g ",*(point+i));
        printf("\n");
}

#include <math.h>
double dist(dim,v1,v2)
int dim;
double *v1,*v2;
{
int i;
double dist = 0;
for (i=0;i<dim;i++)
dist = dist + (v1[i]-v2[i])*(v1[i]-v2[i]);
dist = sqrt(dist);
return dist;
}


#include <math.h>
void per_proj(dim,v1,v2,v3)
int dim;
double *v1,*v2,*v3;
{
int i;
double coeff, dot();
coeff = dot(dim,v1,v2)/dot(dim,v2,v2);
for (i=0;i<dim;i++)
v3[i] = v1[i] - coeff*v2[i];
}

#include <math.h>
double dot(dim,v1,v2)
int dim;
double *v1,*v2;
{
int i;
double dot = 0;
for (i=0;i<dim;i++)
dot = dot + (v1[i]*v2[i]);
return dot;
}

#include <math.h>
double length(dim,v)
int dim;
double *v;
{
int i;
double length = 0;
for (i=0;i<dim;i++)
length = length + v[i]*v[i];
length = sqrt(length);
return length;
}



void fp(f,pt,dim)
int dim;
double *f,*pt;
        {
        double x,y,z, *dvector();
        x = pt[0];
        y = pt[1];
        z = pt[2];
        f[0] = s*(y-x);
        f[1] = r*x-y-x*z;
        f[2] = x*y-b*z;

                }

void free_dvector(v,nl,nh)
double *v;
int nl,nh;
{
        free((char *) (v + nl));
}

double *dvector(nl,nh)
int nl,nh;
{
        double *v;
        v = (double *)malloc((unsigned) (nh - nl + 1) * sizeof(double));
        return(v - nl);
}

int *ivector(nl,nh)
int nl,nh;
{
        int *v;
        v = (int *)malloc((unsigned) (nh - nl + 1) * sizeof(int));
        return(v - nl);
}
