#include <math.h>
#include <stdio.h>
        double r = 28.0,s = 10.0,b = 8.0/3.0,dt;
main()
        {
	double *equilibrium, *dvector();
	double *evone;
	double *evtwo;
	int u_flag,i,dim;
	dim = 3;
	dt = 0.03;
	u_flag = -1.0;
	equilibrium = dvector(0,dim-1);
	evone = dvector(0,dim-1);
	evtwo = dvector(0,dim-1);
	equilibrium[0] = 0.0;
 	equilibrium[1] = 0.0;
	equilibrium[2] = 0.0;
	evone[0] = -.614817;
	evone[1] = -.469335;
	evone[2] = 0.0;
	evtwo[0] = 0.0;
	evtwo[1] = 0.0;
	evtwo[2] = 1.0;
        two_d_mfld(dim,equilibrium,evone,evtwo,u_flag);
        
}

two_d_mfld(dim,equilibrium,evone,evtwo,u_flag)
int dim,u_flag;
double equilibrium[],evone[],evtwo[];
{
double *point ,*p_list,*dvector();
int *triangle, *t_list, *edge, *e_list, blno;
int i,j,t_no,e_no,p_no,b_no, max_step_no,min_index,max_points;
double dist(),length(),length1,length2,lengthp,delman,*en1,*en2,*ep,dot12;
double min_distance,distance_bound,twopi,*d_list,dot(),dst;
double *old_point,*new_point,step_dist,onestep_dist,dt,max_step,min_step,incr_dist;
int *b_list,*ivector();
void onestep();

dim = 3;
max_points = 300;
dt = u_flag*0.03;
min_step = 0.003;
max_step = 0.3;
max_step_no = 50;
distance_bound = 100;
incr_dist = 0.1;
delman = 0.1;
twopi = 6.28318530717958648;
min_distance = delman;
new_point = dvector(0,2);

/*Compute the initial points of manifold as inscribed hexagon in
circle centered at equilibrium with radius delman */

p_no = 0;
p_list = dvector(0,max_points*dim-1); 
en1 = dvector(0,dim-1); 
ep = dvector(0,dim-1); 
en2 = dvector(0,dim-1);
for (i=0;i<dim;i++)
	p_list[i] = equilibrium[i];
p_no++;
length1 = length(dim,evone);
for (i=0;i<dim;i++)
	en1[i] = evone[i]/length1;
dot12 = dot(dim,en1,evtwo);
for (i=0;i<dim;i++)
	ep[i] = evtwo[i] - dot12*en1[i];
lengthp = length(dim,ep);
for (i=0;i<dim;i++)
	en2[i] = ep[i]/lengthp;
for (j=1;j<7;j++) {
	for (i=0;i<dim;i++) {
	p_list[dim*j+i] = equilibrium[i] + delman*(cos(twopi*j/6.0)*en1[i] + sin(twopi*j/6.0)*en2[i]);
	}
p_no++;}
/* The initial complex */
t_no = 0;
e_no = 0;
b_no = 0;
t_list = ivector(0,17); 
e_list = ivector(0,23); 
b_list = ivector(0,17); 
d_list = dvector(0,5); 
for(i=0;i<6;i++) {
	t_list[3*i] = 0; t_list[3*i+1] = i+1; t_list[3*i+2] = 1+(i+1)%6; t_no++;
	e_list[i] = 0; e_list[2*i+1]=i+1; e_no++;
	b_list[3*i] = i+1; 
	b_list[3*i+1] = (i+5)%6+1;
	b_list[3*i+2] = 1+(i+1)%6;
	d_list[i] = delman;
	b_no++;
	print_point(p_list +(i+1)*dim,dim);}
j=e_no;
for(i=j;i<6+j;i++) {
	e_list[2*e_no+i]= i+1; e_list[2*i+1] = 1+(i+1)%6+1; e_no++;}

while (min_distance < distance_bound)

{

/*find_min_vertex*/
min_distance = distance_bound;
min_index = -1;
for(i=0;i<b_no;i++)
	{if (d_list[i] < min_distance) {
min_distance = d_list[i]; min_index = b_list[3*i]; blno = i;}}
if (min_index == -1) return(1);

/* Compute trajectory with min and max distance bounds */
point = p_list + 3*min_index;
old_point = point;
	for(i=0;i<max_step_no;i++) {
	onestep(dt,old_point,new_point,dim);
	onestep_dist = dist(dim,old_point,new_point);
	if (onestep_dist > max_step) {
		dst = 0.25*dt*max_step/onestep_dist;
		onestep(dst,old_point,new_point,dim);
		step_dist = dist(dim,point,new_point);
		break;}
	if (onestep_dist < min_step) {step_dist = distance_bound; break;}
	step_dist = dist(dim,point,new_point);
	if (step_dist > incr_dist) break;
	for (i=0;i<dim;i++) old_point[i] = new_point[i]; 
	}
	 
/*Add the new point to lists and update boundary */
d_list[blno] = step_dist;
print_point(new_point,dim);
for(i=0;i<dim;i++) p_list[p_no*dim+i] = new_point[i];
b_list[3*blno] = p_no; 
p_no++;

/*Check boundary distances and interpolate boundary list*/
}
}


print_point(point,dim)
double *point;
int dim;
{ 

	int i ;
	printf("%%XC1 ");
	for(i=0;i<dim;i++) printf("%g ",*(point+i));
	printf("\n");
}

#include <math.h>
double dist(dim,v1,v2)
int dim;
double *v1,*v2;
{
int i;
double dist = 0;
for (i=0;i<dim;i++)
dist = dist + (v1[i]-v2[i])*(v1[i]-v2[i]);
dist = sqrt(dist);
return dist;
}
#include <math.h>
double dot(dim,v1,v2)
int dim;
double v1[],v2[];
{
int i;
double dot = 0;
for (i=0;i<dim;i++)
dot = dot + (v1[i]*v2[i]);
dot = sqrt(dot);
return dot;
}
#include <math.h>
double length(dim,v)
int dim;
double *v;
{
int i;
double length = 0;
for (i=0;i<dim;i++)
length = length + v[i]*v[i];
length = sqrt(length);
return length;
}



void onestep(dt,old_point,new_point,dim)
double dt, *old_point, *new_point;
int dim;
{
double t,*dvector(), *point, *f;
int i;
void fp(),rk4();
t=0.0;
f = dvector(0,2);
point = dvector(0,2);
for (i=0;i<dim;i++) point[i] = old_point[i];
fp(f,point,dim);
rk4(point,f,dim,t,dt,new_point);
}


void fp(f,pt,dim)
int dim;
double *f,*pt;
        {
        double x,y,z, *dvector();
        x = pt[0];
        y = pt[1];
        z = pt[2];
        f[0] = s*(y-x);
        f[1] = r*x-y-x*z;
        f[2] = x*y-z;

                }

/*
Note: 	slightly modified version of 4-th order Runge-Kutta integrator "rk4"
	in "Numerical Recipes"
	c convention of [0,n-1] is used
*/

void
rk4(y,f,n,x,h,yout)
double *y,*f,x,h,*yout;
int n;
{
	int i;
	double xh,hh,h6,*dym,*dyt,*yt,*dvector();
	void free_dvector();
	void fp();

	dym = dvector(0,n-1);
	dyt = dvector(0,n-1);
	yt = dvector(0,n-1);
	hh = h * 0.5;
	h6 = h / 6.0;
	xh = x + hh;
	for(i=0;i<n;i++) yt[i] = y[i] + hh * f[i];
	fp(dyt,yt,n);
	for(i=0;i<n;i++) yt[i] = y[i] + hh * dyt[i];
	fp(dym,yt,n);
	for(i=0;i<n;i++){
		yt[i] = y[i] + h * dym[i];
		dym[i] += dyt[i];
	}
	fp(dyt,yt,n);
	for(i=0;i<n;i++){
		yout[i] = y[i] + h6 * (f[i] + dyt[i] + 2.0 * dym[i]);
	}
	free_dvector(yt,0,n-1);
	free_dvector(dyt,0,n-1);
	free_dvector(dym,0,n-1);
}

void free_dvector(v,nl,nh)
double *v;
int nl,nh;
{
	free((char *) (v + nl));
}

double *dvector(nl,nh)
int nl,nh;
{
	double *v;
	v = (double *)malloc((unsigned) (nh - nl + 1) * sizeof(double));
	return(v - nl);
}

int *ivector(nl,nh)
int nl,nh;
{
	int *v;
	v = (int *)malloc((unsigned) (nh - nl + 1) * sizeof(int));
	return(v - nl);
}
