/*
 * $Id: flow.h,v 1.3 1997/05/12 15:45:27 veran Exp $
 */

/*
 * flow.h
 *
 * Declarations for flow routines
 */

#ifndef FLOW_H
#define FLOW_H

#include "complib.h"

/* flow.c */
void flow_forwards(void);
void flow_backwards(void);
void flow_continue(void);
void clear_last_trajectory(void);
void clear_all_trajs(void);

/* traj_mem_orb.c */
void traj_mem_orbit(void);
int allocate_integ(struct Prop_DataS *ic, int size);
int release_integ(struct Prop_DataS *ic, int size);
void bump_color(void);
void unbump_color(void);
void reset_color(void);
int get_alt_color(void);
void prop_struct_dump(struct Prop_DataS *ic);

/* load_int.c */
void load_int(void);
void prop_to_pm(void);

/* compute_orb.c */
int compute_orbit(struct Prop_DataS *prop_cntl);
int prop_cntl_orbit(struct Prop_DataS *prop_cntl);
int comp_alloc(struct Prop_DataS *prop_cntl);
int comp_free(struct Prop_DataS *prop_cntl);
void watch_free(struct Prop_DataS *prop_cntl);
int comp_def_setup(struct Prop_DataS *prop_cntl);
int varb_watch_func(double x[], double p[], int index, double *result);
int aux_fn_watch_func(double x[], double p[], int index, double *result);
void watch_setup(struct Prop_DataS *prop_cntl);

/* orbits/integration/iterate.c */
int iterate(struct Prop_DataS *prop_cntl);
int implicit_iter( int (*f)(double*, double* , double* ),
                   int (*jacobian)(double**, double*, double*),
                   int jacobian_switch,
                   int newt_iter,
                   int k,
                   double** m,
                   double* x,
                   double* c,
                   double* param,
                   int ph_sp_dim,
                   double time_step,
                   double* h,
                   double tolx,
                   double tolf,
                   Manifold* manifold,
                   double* y,
                   int* indx);


/* orbits/iteration/integrate.c */
int integrate(struct Prop_DataS *prop_cntl);

#endif
/* !FLOW_H */
