/*
 * $Id: algorithms_local.h,v 1.2 1997/05/12 15:46:26 veran Exp $
 */



/*
 * algorithms_local.h
 *
 */
#ifndef _ALGORITHMS_LOCAL_h_
#define _ALGORITHMS_LOCAL_h_

#include <complib.h>

/* ab4.c */
int ab4( double* vx1, double* vx, double* param, double time_step,
         int dim, int (*f_p)(double*, double*, double*),
         double* workspace, History_Struct* history_list);


/* euler.c */
int euler_driver(double *out_state, double *in_state, double *dwork,
	     struct Prop_DataS *integ_cntl, int mode);
int euler(double *vx1, double *vx, double *param, double time_step,
      int dim,int (*f_p)(double *, double *, double *), double *workspace);
int euler_init(void);

/* rk4.c */
int rk4_driver(double *out_state, double *in_state, double *dwork, 
	   struct  Prop_DataS *integ_cntl, int mode);
int rk4(double *vx1, double *vx, double *param, double time_step,
    int dim, int (*f_p)(double *, double *, double *), double *workspace);
int rk4_init(void);


/* rk78.c */
int rk78_driver(double *out_state, double *in_state, double *dwork,
	    struct Prop_DataS *integ_cntl, int mode);
int rk78_init(void);

/* rkqc.c */
int rkqc_driver(double *out_state, double *in_state, double *dwork,
		struct Prop_DataS *integ_cntl, int mode);
int rkqc_init(void);

/* bs.c */
int bs_driver(double *out_state, double *in_state, double *dwork,
	      struct Prop_DataS *integ_cntl, int mode);
int bs_init(void);

#endif
/* !_ALGORITHMS_LOCAL_h_ */
